<?php
ini_set("display_errors", "on");

class ControllerExtensionPaymentMoka extends Controller {
	private $error = array();
	
	/*	
	*	Do not change following lines, 
	*	will be used for checking updates and for support processes 
	*/
	private $id_eticsoft = 301;
	private $key_eticsoft = '7c6f165563a785c341a9eddc324a983a';
	private $version = 1.0;
	/* -- */
	
	public function install () {
		$this->load->model('extension/payment/moka');

		$this->model_extension_payment_moka->install();
	}
	

	public function index() {
		$this->load->language('payment/moka');
		
		$this->document->setTitle('Kredi Kartı İle Ödeme');

		$this->load->model('setting/setting');
		
		include(DIR_CATALOG.'controller/payment/mokaconfig.php');

		if (isset($this->request->post['moka_submit'])) {
			$this->model_setting_setting->editSetting('moka', $this->request->post);			
			$this->session->data['success'] = $this->language->get('text_success');
			$this->response->redirect($this->url->link('extension/payment/moka', 'token=' . $this->session->data['token'] . '&type=payment', true));
		}
		if (isset($this->request->post['confirm_moka_register'])) {
			$this->model_setting_setting->editSetting('moka', array('moka_registered' => "ok"));
			$this->registerMoka();
			$this->response->redirect($this->url->link('extension/payment/moka', 'token=' . $this->session->data['token'] . '&type=payment', true));
		}


		$data['heading_title'] = $this->language->get('heading_title');
		$data['text_edit'] = $this->language->get('text_edit');
		$data['help_total'] = $this->language->get('help_total');
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['moka_registered'] = $this->config->get('moka_registered');

		
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}
		if($this->config->get('moka_username') == null)
			$data['error_warning'] .= 'Moka Username Alanı Boş<br/>';
			
		if($this->config->get('moka_password') == null)
			$data['error_warning'] .= 'Moka Şifre Alanı Boş<br/>';
		
		
		if($this->config->get('moka_rates') == NULL)
			$this->config->set('moka_rates', MokaConfig::setRatesDefault());
		
		
		if (isset($this->request->post['moka_3d_mode'])) {
			$data['moka_3d_mode'] = $this->request->post['moka_3d_mode'];
		} else {
			$data['moka_3d_mode'] = $this->config->get('moka_3d_mode');
		}
		
		if (isset($this->request->post['moka_dealercode'])) {
			$data['moka_dealercode'] = $this->request->post['moka_dealercode'];
		} else {
			$data['moka_dealercode'] = $this->config->get('moka_dealercode');
		}
		if (isset($this->request->post['moka_username'])) {
			$data['moka_username'] = $this->request->post['moka_username'];
		} else {
			$data['moka_username'] = $this->config->get('moka_username');
		}
		if (isset($this->request->post['moka_password'])) {
			$data['moka_password'] = $this->request->post['moka_password'];
		} else {
			$data['moka_password'] = $this->config->get('moka_password');
		}

		if (isset($this->request->post['moka_ins_tab'])) {
			$data['moka_ins_tab'] = $this->request->post['moka_ins_tab'];
		} else {
			$data['moka_ins_tab'] = $this->config->get('moka_ins_tab');
		}
		
		if (isset($this->request->post['moka_status'])) {
			$data['moka_status'] = $this->request->post['moka_status'];
		} else {
			$data['moka_status'] = $this->config->get('moka_status');
		}
		if (isset($this->request->post['moka_order_status_id'])) {
			$data['moka_order_status_id'] = $this->request->post['moka_order_status_id'];
		} else {
			$data['moka_order_status_id'] = $this->config->get('moka_order_status_id');
		}
		$this->load->model('localisation/order_status');
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
        if (isset($this->request->server['HTTPS']) && (($this->request->server['HTTPS'] == 'on') || ($this->request->server['HTTPS'] == '1'))) {
                $data['base'] = $this->config->get('config_ssl');
        } else {
                $data['base'] = $this->config->get('config_url');
        }
        		
		$data['moka_rates_table'] = MokaConfig::createRatesUpdateForm($this->config->get('moka_rates'));
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);
		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_payment'),
			'href' => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL')
		);
		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('payment/moka', 'token=' . $this->session->data['token'], 'SSL')
		);
		$data['action'] = $this->url->link('extension/payment/moka', 'token=' . $this->session->data['token'], 'SSL');
		$data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');
		$this->response->setOutput($this->load->view('payment/moka.tpl', $data));
	}
	
	private function registerMoka($url = "")
    {
		$d = $_SERVER['HTTP_HOST'];
        if (substr($d, 0, 4) == " www.")
            $d = substr($d, 4);
        $data = array();
        $data['product_id'] = $this->id_eticsoft;
        $data['product_version'] = $this->version;
        $data['product_name'] = 'Opencart Moka SanalPOS';
        $data['key_eticsoft'] = $this->key_eticsoft;
        $data['merchant_email'] = $this->config->get('config_email');
        $data['merchant_domain'] = $d;
        $data['merchant_ip'] = $_SERVER['SERVER_ADDR'];
        $data['merchant_name'] = $this->config->get('config_name');
        $data['merchant_version'] = VERSION;
        $data['merchant_software'] = 'Opencart';
        $data['hash_key'] = md5($d . $this->version);
        return json_decode($this->CurlPostExt(array("q" => json_encode($data)), 'http://api.eticsoft.net/license/'));
    }

    private function curlPostExt($data, $url, $json = false)
    {
        $ch = curl_init(); // initialize curl handle
        curl_setopt($ch, CURLOPT_URL, $url); // set url to post to
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // return into a variable
        if ($json)
            curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-type: application/json"));
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30); // times out after 4s
        curl_setopt($ch, CURLOPT_POST, 1); // set POST method
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data); // add POST fields
        if ($result = curl_exec($ch)) { // run the whole process
            curl_close($ch);
            return $result;
        }
        return false;
    }

    function getRecordById($id_order)
    {
        if (!$id_order
                OR ! $order = New Order((int) $id_order)
                OR $order->module != 'eticsoft_moka')
            return false;
        
        

        $moka_order_id = 'ETIC_' . $order->id_cart . '-' . $order->id_customer;
                
        $url = 'https://service.moka.com/PaymentDealer/GetDealerPaymentTrxDetailList';
        $dealercode = $this->config->get('moka_dealercode');
        $username = $this->config->get('moka_username');
        $password = $this->config->get('moka_password');

        $moka['PaymentDealerAuthentication'] = array(
            'DealerCode' => $dealercode,
            'Username' => $username,
            'Password' => $password,
            'CheckKey' => hash('sha256', $dealercode . 'MK' . $username . 'PD' . $password)
        );
        $moka['PaymentDealerRequest'] = array(
            'DealerPaymentId' => null,
            'OtherTrxCode' => $moka_order_id
        );
        return json_decode($this->curlPostExt(json_encode($moka), $url, true));
    }

    function getallRecords($from = false)
    {
        if (!$from)
            $from = date("Y-m") . '-01 00:00';
        $url = 'https://service.moka.com/PaymentDealer/GetPaymentList';
        $dealercode = $this->config->get('moka_dealercode');
        $username = $this->config->get('moka_username');
        $password = $this->config->get('moka_password');
		
        $moka['PaymentDealerAuthentication'] = array(
            'DealerCode' => $dealercode,
            'Username' => $username,
            'Password' => $password,
            'CheckKey' => hash('sha256', $dealercode . 'MK' . $username . 'PD' . $password)
        );
        $moka['PaymentDealerRequest'] = array(
            'PaymentStartDate' => $from,
            'PaymentEndDate' => date("Y-m-d H:i")
        );
        return json_decode($this->curlPostExt(json_encode($moka), $url, true));
    }

	protected function validate() {
		
		if (!$this->user->hasPermission('modify', 'payment/moka')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		return true;
		
		$this->load->model('localisation/language');

		$languages = $this->model_localisation_language->getLanguages();

		foreach ($languages as $language) {
			if (empty($this->request->post['moka_bank' . $language['language_id']])) {
				$this->error['bank' .  $language['language_id']] = $this->language->get('error_bank');
			}
		}

		return !$this->error;
	}
}