<?php
echo $header;
echo $column_left; ?>
<div id="content">
    <div class="page-header">
        <div class="container-fluid">
            <div class="pull-right">
                <button type="submit" form="form-moka-settings" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-primary"><i class="fa fa-save"></i></button>
                <a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $button_cancel; ?>" class="btn btn-default"><i class="fa fa-reply"></i></a></div>
            <h1>Moka Kredi Kartı Ödeme Modülü</h1>
            <ul class="breadcrumb">
                <?php foreach ($breadcrumbs as $breadcrumb) { ?>
                <li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
                <?php } ?>
            </ul>
        </div>
    </div>

    <div class="container-fluid">
        <?php if(!$moka_registered OR $moka_registered == null) { ?>
        <br/><hr/>
        <form action="" method="post">
            <div class="alert alert-warning">
                <h2>Kullanım Şartları </h2>
                <ul>
                    <li>Moka modülü Moka Ödeme Kuruluşu A.Ş tarafından GPL lisansı ile açık kaynaklı ve ücretsiz sunulmaktadır. <b>Satılamaz.</b></li>
                    <li>Moka modülü Moka Ödeme Kuruluşu A.Ş 'nin sağladığı servisleri kullanmak için geliştirilmiştir. Başka amaçla kullanılamaz.</li>
                    <li>Uluslararası güvenlik standartlarında kredi kartı bilgilerine erişim veya bilgilerin kayıt edilmesi yasaktır. Bu modül orijinal kaynak kodlarıyla müşterilerinizin kredi kartı bilgilerini asla kaydetmez. Kaynak kodlarını bu kurallara uygun tutmak sizin sorumluluğunuzdadır.</li>
                    <li>Bazı mağaza bilgileriniz (mağaza eposta, mağaza adresi ve versiyon) geliştirici teknik destek ve bilgilendirme sistemine otomatik kayıt edilecek ve bu bilgiler önemli bildirimler ile güncellemelerden haberdar olmanız için kullanılacaktır</li>
                    <li>Mağaza bilgileriniz asla 3. kişi ve kurumlar ile paylaşılmaz.</li>
                </ul>
                <hr>
                <input type="checkbox" value="1" name="confirm_moka_register" checked><br/>
                    <label for="confirm_moka">Kullanım şartlarını kabul ediyorum</label>
                    <br>
                    <button type="submit" class="btn btn-primary">Mağazamı Kaydet ve Başla</button>
            </div>
        </form>
        <?php } else {?>
        <?php if ($error_warning) { ?>
        <div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
            <button type="button" class="close" data-dismiss="alert">&times;</button>
        </div>
        <?php } ?>
        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_edit; ?></h3>
            </div>

            <div class="panel-body">
                <ul class="nav nav-tabs" id="tabs">
                    <li class="active"><a href="#tab-moka_settings" data-toggle="tab">Genel Ayarlar</a></li>
                    <li><a href="#tab-moka_rates" data-toggle="tab">Taksit Oranları</a></li>
                    <li><a href="#tab-moka_about" data-toggle="tab">Moka Hakkında</a></li>
                    <li><a href="#tab-moka_help" data-toggle="tab">Yardım&Teknik destek</a></li>
                </ul>
                <div class="tab-content">
                    <div class="tab-pane active" id="tab-moka_settings">
                        <form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form-moka-settings" class="form-horizontal">
                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="moka_dealercode"><span data-toggle="tooltip" title="<?php echo $help_total; ?>">Moka Bayi Kodu</span></label>
                                <div class="col-sm-10">
                                    <input type="text" name="moka_dealercode" value="<?php echo $moka_dealercode; ?>" placeholder="123.." id="moka_dealercode" class="form-control" />
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="moka_username"><span data-toggle="tooltip" title="<?php echo $help_total; ?>">Moka Kullanıcı Adı</span></label>
                                <div class="col-sm-10">
                                    <input type="text" name="moka_username" value="<?php echo $moka_username; ?>" placeholder="X1Y2Z3Q4..." id="moka_username" class="form-control" />
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="moka_password"><span data-toggle="tooltip" title="<?php echo $help_total; ?>">Moka Şifre </span></label>
                                <div class="col-sm-10">
                                    <input type="text" name="moka_password" value="<?php echo $moka_password; ?>" placeholder="X1Y2Z3Q4A5B6C7Z8..." id="moka_password" class="form-control" />
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="moka_ins_tab"><span data-toggle="tooltip" title="<?php echo $help_total; ?>">Taksit Seçenekleri Sekmesi</span></label>
                                <div class="col-sm-10">
                                    <select name="moka_ins_tab" id="input-moka_ins_tab" class="form-control">              
                                        <option value="on">Göster</option>
                                        <option value="off" <?php if ($moka_ins_tab == 'off') { ?>selected="selected"<?php } ?>>Gizle</option>
                                    </select>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="input-order-status">3D Secure Yönetimi</label>
                                <div class="col-sm-10">
                                    <select name="moka_3d_mode" id="input-moka_3d_mode" class="form-control">              
                                        <option value="on" <?php if ($moka_3d_mode == 'on') { ?>selected="selected"<?php } ?>>Tüm ödemeler 3DS ile yapılsın (SMS ile şifre gönder) </option>
                                        <option value="off" <?php if ($moka_3d_mode == 'off') { ?>selected="selected"<?php } ?>>Asla 3DS kullanma (Hızlı tek sayfada ödeme)</option>
                                    </select>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="input-status">Modül Durumu</label>
                                <div class="col-sm-10">
                                    <select name="moka_status" id="input-status" class="form-control">                
                                        <option value="1" selected="selected">Aktif</option>
                                        <option value="0" <?php if (!$moka_status) { ?> checked="checked" <?php } ?> >Pasif</option>
                                    </select>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-sm-2 control-label" for="input-status">Sipariş Durumu</label>
                                <div class="col-sm-10">
                                    <select name="moka_order_status_id" id="input-order-status" class="form-control">
                                        <?php foreach ($order_statuses as $order_status) { ?>
                                        <?php if ($order_status['order_status_id'] == $moka_order_status_id) { ?>
                                        <option value="<?php echo $order_status['order_status_id']; ?>" selected="selected"><?php echo $order_status['name']; ?></option>
                                        <?php } else { ?>
                                        <option value="<?php echo $order_status['order_status_id']; ?>"><?php echo $order_status['name']; ?></option>
                                        <?php } ?>
                                        <?php } ?>
                                    </select>
                                </div>
                            </div>
                            <input type="hidden" name="moka_submit" value="1"/>
                    </div>
                    <div class="tab-pane" id="tab-moka_rates">
                        <div class="form-group">
                            <?php echo $moka_rates_table ?>
                        </div>
                        <input type="hidden" name="moka_rates_submit" value="1"/>
                        <input type="hidden" name="moka_registered" value="ok"/>
                        <button type="submit" form="form-moka-rates" data-toggle="tooltip" title="Oranları kaydet" class="btn btn-primary">Oranları kaydet</button>

                        </form>
                    </div>
                    <div class="tab-pane" id="tab-moka_about">
                        <div class="panel">
                            <div class="row eticsoft_moka-header">
                                <img src="../catalog/view/theme/default/image/moka/moka_logo.png" class="col-xs-4 col-md-2 text-center" id="payment-logo" />
                                <div class="col-xs-6 col-md-5 text-center">
                                    <h4>Moka Ödeme Kuruluşu A.Ş.</h4>
                                    <h4>Hızlı Güvenli ve Kolay</h4>
                                </div>
                                <div class="col-xs-12 col-md-5 text-center">
                                    <a href="https://moka.com" class="btn btn-primary" id="create-account-btn">Moka SanalPOS'a başvurun</a><br />
                                    Moka SanalPOS'unuz varsa ?<a href="https://pos.moka.com"> Hesabınıza giriş yapın</a>
                                </div>
                            </div>

                            <hr />


                            <div class="eticsoft_moka-content">
                                <div class="row">
                                    <div class="col-md-4 col-sm-4">
                                        <div class="thumbnail">
                                            <figure class="figure text-center">
                                                <img src="../catalog/view/theme/default/image/moka/icons/icon_clock.png" width="140" height="100"/>
                                            </figure>
                                            <p class="text text-center">
                                                7x24 kesintisiz
                                                <br>tahsilat imkanı
                                            </p>
                                        </div>
                                    </div>
                                    <div class="col-md-4 col-sm-4">
                                        <div class="thumbnail">
                                            <figure class="figure text-center">
                                                <img src="../catalog/view/theme/default/image/moka/icons/icon_money.png" width="140" height="100"/>
                                            </figure>
                                            <p class="text text-center">
                                                Hesaplı
                                                <br>satış avantajı
                                            </p>
                                        </div>
                                    </div>
                                    <div class="col-md-4 col-sm-4">
                                        <div class="thumbnail">
                                            <figure class="figure text-center">
                                                <img src="../catalog/view/theme/default/image/moka/icons/icon_credit_card.png" width="140" height="100"/>
                                            </figure>
                                            <p class="text text-center">
                                                Bütün kredi kartları için
                                                <br>taksitli satış imkanı
                                            </p>
                                        </div>
                                    </div>
                                    <div class="col-md-4 col-sm-4">
                                        <div class="thumbnail">
                                            <figure class="figure text-center">
                                                <img src="../catalog/view/theme/default/image/moka/icons/icon_visa_mastercard.png" width="140" height="100"/>
                                            </figure>
                                            <p class="text text-center">
                                                Visa ve MasterCard
                                                <br>tahsilat imkanı
                                            </p>
                                        </div>
                                    </div>
                                    <div class="col-md-4 col-sm-4">
                                        <div class="thumbnail">
                                            <figure class="figure text-center">
                                                <img src="../catalog/view/theme/default/image/moka/icons/icon_exchange.png" width="140" height="100"/>
                                            </figure>
                                            <p class="text text-center">
                                                Yabancı kartlar ile
                                                <br>işlem yapabilme
                                            </p>
                                        </div>
                                    </div>
                                    <div class="col-md-4 col-sm-4">
                                        <div class="thumbnail">
                                            <figure class="figure text-center">
                                                <img src="../catalog/view/theme/default/image/moka/icons/icon_cogs.png" width="140" height="100"/>
                                            </figure>
                                            <p class="text text-center">
                                                Hızlı ve kolay
                                                <br>entegrasyon
                                            </p>
                                        </div>
                                    </div>
                                </div>
                                <hr />
                            </div>
                        </div>					





                    </div>
                    <div class="tab-pane" id="tab-moka_help">

                        <div class="panel">
                            <div class="row">   
                                <div class="alert alert-success"> Bu plugin için teknik destek işlemleri Moka Ödeme A.Ş. adına <a href="https://eticsoft.com">EticSoft</a> tarafından <b>ÜCRETSİZ</b> sağlanmaktadır</div>
                            </div>
                            <div class="row">
                                <div class="col-sm-6 text-center">            
                                    <h1>Yardıma mı ihtiyacınız var? <br/> Hemen eticsoft'u çağırın !</h1>
                                    <div class="row">
                                        <div class="col-sm-2"></div>
                                        <img src="../catalog/view/theme/default/image/moka/help2.png" class="col-sm-8 text-center" id="payment-logo" />
                                        <div class="col-sm-2"></div>
                                    </div>
                                </div>
                                <div class="col-sm-6 panel text-center">
                                    <h1>Destek Kanalları</h1><hr/>
                                    <a class="btn btn-info btn-large" href="https://eticsoft.com/dokumantasyon/prestashop-moka-sanalpos/"><i class="icon icon-book"> </i> Kullanım Klavuzu</a> <hr/>
                                    <a class="btn btn-success btn-large" href="https://eticsoft.com/support/submitticket.php?step=2&deptid=10"><i class="icon icon-ambulance"> </i> Ticket destek sistemi</a> <hr/>
                                    <a class="btn btn-info btn-large"><i class="icon icon-phone"> </i> Telefon 0242 241 59 85</a> <hr/>
                                    <a href="https://eticsoft.com"><img src="../catalog/view/theme/default/image/moka/eticsoft_logo.png" width="150px" /></a><br/>

                                </div>

                                <hr/>
                            </div>

                            <div class="panel">
                                <div class="col-sm-12 text-center">
                                    <a href="https://www.facebook.com/EticSoft/"><img src="../catalog/view/theme/default/image/moka/icons/facebook.png" width="32px" /></a>
                                    <a href="https://twitter.com/eticsoft"><img src="../catalog/view/theme/default/image/moka/icons/twitter.png" width="32px" /></a>
                                    <a href="https://www.youtube.com/user/EticSoft"><img src="../catalog/view/theme/default/image/moka/icons/youtube.png" width="32px" /></a>
                                    <a href="https://www.linkedin.com/company/eticsoft-yaz%C4%B1l%C4%B1m"><img src="../catalog/view/theme/default/image/moka/icons/linkedin.png" width="32px" /></a>
                                    <a href="https://www.instagram.com/eticsoft/"><img src="../catalog/view/theme/default/image/moka/icons/instagram.png" width="32px" /></a>
                                    <a href="https://wordpress.org/support/users/eticsoft-lab/"><img src="../catalog/view/theme/default/image/moka/icons/wordpress.png" width="32px" /></a>
                                    <a href="https://github.com/eticsoft/"><img src="../catalog/view/theme/default/image/moka/icons/github.png" width="32px" /></a>
                                </div>
                                <hr/>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<?php } ?>
<?php echo $footer; ?>
<style>
    #content .tab-pane:first-child .panel {
        border-top-left-radius: 0;
    }

    .moka-header .text-branded,
    .moka-content .text-branded {
        color: #00aff0;
    }

    .moka-header h4,
    .moka-content h4,
    .moka-content h5 {
        margin: 2px 0;
        color: #00aff0;
        font-size: 1.8em;
    }

    .moka-header h4 {
        margin-top: 5px;
    }

    .moka-header .col-md-6 {
        margin-top: 18px;
    }

    .moka-content h4 {
        margin-bottom: 10px;
    }

    .moka-content h5 {
        font-size: 1.4em;
        margin-bottom: 10px;
    }

    .moka-content h6 {
        font-size: 1.3em;
        margin: 1px 0 4px 0;
    }

    .moka-header > .col-md-4 {
        height: 65px;
        vertical-align: middle;
        border-left: 1px solid #ddd;
    }

    .moka-header > .col-md-4:first-child {
        border-left: none;
    }

    .moka-header #create-account-btn {
        margin-top: 14px;
    }

    .moka-content dd + dt {
        margin-top: 5px;
    }

    .moka-content ul {
        padding-left: 15px;
    }

    .moka-content .ul-spaced li {
        margin-bottom: 5px;
    }
    table.moka_table {
        width:90%;
        margin:auto;
    }
    table.moka_table td,th {
        width: 60px;
        margin:0px;
        padding:2px;
    }
    table.moka_table input[type="number"] {
        width:50px;
    }
</style>