<?php

Class MokaConfig
{

    const max_installment = 9;

    public static function getAvailablePrograms()
    {
	return array(
	    'axess' => array('name' => 'Axess', 'bank' => 'Akbank A.Ş.'),
	    'word' => array('name' => 'WordCard', 'bank' => 'Yapı Kredi Bankası'),
	    'bonus' => array('name' => 'BonusCard', 'bank' => 'Garanti Bankası A.Ş.'),
	    'cardfinans' => array('name' => 'CardFinans', 'bank' => 'FinansBank A.Ş.'),
	    'asyacard' => array('name' => 'AysaCard', 'bank' => 'BankAsya A.Ş.'),
	    'maximum' => array('name' => 'Maximum', 'bank' => 'T.C. İş Bankası'),
	    'paraf' => array('name' => 'Paraf', 'bank' => 'T Halk Bankası A.Ş.'),
	);
    }

    public static function setRatesFromPost($posted_data)
    {
	$banks = MokaConfig::getAvailablePrograms();
	$return = array();
	foreach ($banks as $k => $v) {
	    $return[$k] = array();
	    for ($i = 1; $i <= self::max_installment; $i++) {
		$return[$k][$i] = isset($posted_data[$k]['installments'][$i]) ? ((float) $posted_data[$k]['installments'][$i]) : 0.0;
		if ($posted_data[$k]['installments'][$i]['passive']) {
		    $return[$k][$i] = -1.0;
		}
	    }
	}
	return $return;
    }

    public static function setRatesDefault()
    {
	$banks = MokaConfig::getAvailablePrograms();
	$return = array();
	foreach ($banks as $k => $v) {
	    $return[$k] = array();
	    for ($i = 1; $i <= self::max_installment; $i++) {
		$return[$k]['installments'][$i] = (float) (1 + $i + ($i / 5) + 0.1);
		if ($i == 1)
		    $return[$k]['installments'][$i] = 0.00;
	    }
	}
	return $return;
    }

    public static function createRatesUpdateForm($rates)
    {
	$return = '<table class="moka_table table">'
		. '<thead>'
		. '<tr><th>Banka</th>';
	for ($i = 1; $i <= self::max_installment; $i++) {
	    $return .= '<th>' . $i . ' taksit</th>';
	}
	$return .= '</tr></thead><tbody>';

	$banks = MokaConfig::getAvailablePrograms();
	foreach ($banks as $k => $v) {
	    $return .= '<tr>'
		    . '<th><img src="'.HTTPS_CATALOG.'catalog/view/theme/default/image/moka/banks/' . $k . '.png"></th>';
	    for ($i = 1; $i <= self::max_installment; $i++) {
		$return .= '<td><input type="number" step="0.001" maxlength="4" size="4" '
			. ' value="' . ((float) $rates[$k]['installments'][$i]) . '"'
			. ' name="moka_rates[' . $k . '][installments][' . $i . ']"/></td>';
	    }
	    $return .= '</tr>';
	}
	$return .= '</tbody></table>';
	return $return;
    }

    public static function calculatePrices($price, $rates)
    {
	$banks = MokaConfig::getAvailablePrograms();
	$return = array();
	foreach ($banks as $k => $v) {
	    $return[$k] = array();
	    for ($i = 1; $i <= self::max_installment; $i++) {
			$return[$k]['installments'][$i] = array(
				'total' => number_format((((100 + $rates[$k]['installments'][$i]) * $price) / 100), 2, '.', ''),
				'monthly' => number_format((((100 + $rates[$k]['installments'][$i]) * $price) / 100) / $i, 2, '.', ''),
			);
	    }
	}
	return $return;
    }

    public function getRotatedRates($price, $rates)
    {
	$prices = MokaConfig::calculatePrices($price, $rates);
	for ($i = 1; $i <= self::max_installment; $i++) {
	    
	}
    }

    public static function createInstallmentsForm($price, $rates)
    {
	$prices = MokaConfig::calculatePrices($price, $rates);
	$return = '<table class="moka_table table">'
		. '<thead>'
		. '<tr><th>Banka</th>';
	for ($i = 1; $i <= self::max_installment; $i++) {
	    $return .= '<th>' . $i . ' taksit</th>';
	}
	$return .= '</tr></thead><tbody>';

	$banks = MokaConfig::getAvailablePrograms();
	foreach ($banks as $k => $v) {
	    $return .= '<tr>'
		    . '<th><img src="/modules/moka/views/img/banks/' . $k . '.png"></th>';
	    for ($i = 1; $i <= self::max_installment; $i++) {
		$return .= '<td><input type="number" step="0.001" maxlength="4" size="4" '
			. ' value="' . ((float) $rates[$k]['installments'][$i]) . '"'
			. ' name="moka_rates[' . $k . '][installments][' . $i . ']"/></td>';
	    }
	    $return .= '</tr>';
	}
	$return .= '</tbody></table>';
	return $return;
    }

}
