<?php

/*
 * Do not change following lines 
 */
if (!defined('_MOKA_API_URL_'))
    define('_MOKA_API_URL_', 'https://service.moka.com/PaymentDealer/DoDirectPayment');
if (!defined('_MOKA_3D_URL_'))
    define('_MOKA_3D_URL_', 'https://service.moka.com/PaymentDealer/DoDirectPaymentThreeD');
/**/

class ControllerPaymentMoka extends Controller
{

    public function index()
    {
        $this->load->language('payment/moka');
        $this->document->addStyle('catalog/view/theme/default/stylesheet/moka_form.css');

        $data['text_instruction'] = $this->language->get('text_instruction');
        $data['text_description'] = $this->language->get('text_description');
        $data['text_payment'] = $this->language->get('text_payment');
        $data['text_loading'] = $this->language->get('text_loading');

        $data['button_confirm'] = $this->language->get('button_confirm');

        $data['bank'] = nl2br($this->config->get('moka_bank' . $this->config->get('config_language_id')));

        $data['continue'] = $this->url->link('checkout/success');

        if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/moka.tpl')) {
            return $this->load->view($this->config->get('config_template') . '/moka.tpl', $data);
        } else {
            return $this->load->view('default/moka.tpl', $data);
        }
    }

    public function paymentform()
    {

        $this->load->model('checkout/order');
        $this->load->model('setting/setting');
        require_once(DIR_APPLICATION . 'controller/payment/mokaconfig.php');
        if (!isset($this->session->data['order_id']) OR ! $this->session->data['order_id'])
            die('Sipariş ID bulunamadı');

        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        $record = array('result_code' => false, 'result_message' => false);

        $cc_form_key = md5($order_info['order_id'] . $order_info['store_url']);
        $total_cart = $order_info['total'];
        $order_id = $this->session->data['order_id'];

        if (isset($this->request->post['cc_form_key']) && $this->request->post['cc_form_key'] == $cc_form_key) {
            $record = $this->post2Moka();
        }
        if (isset($_POST['isSuccessful']) AND $_POST['isSuccessful']) {
            $record['result_code'] = $_POST['resultCode'];
            $record['result_message'] = $_POST['resultMessage'];
            $record['result'] = $_POST['isSuccessful'] == 'True' ? true : false;
        }

        if (isset($record['result']) AND $record['result']) {
            $record['id_order'] = $order_id;
            $comment = $this->record2Table($this->getRecordById('ETIC'.$order_id));
            $this->session->data['payment_method']['code'] = 'moka';
            $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('moka_order_status_id'), $comment);
            $this->response->redirect($this->url->link('checkout/success', '', 'SSL'));
        }

        $data['column_left'] = $this->load->controller('common/column_left');
        $data['column_right'] = $this->load->controller('common/column_right');
        $data['content_top'] = $this->load->controller('common/content_top');
        $data['content_bottom'] = $this->load->controller('common/content_bottom');
        $data['footer'] = $this->load->controller('common/footer');
        $data['header'] = $this->load->controller('common/header');


        $moka_rates = MokaConfig::calculatePrices($total_cart, $this->config->get('moka_rates'));
        $data['cc_form_key'] = $cc_form_key;
        $data['rates'] = $moka_rates;
        $data['error_message'] = $record['result_message'];
        $data['cart_id'] = $this->session->data['order_id'];
        $data['form_link'] = $this->url->link('payment/moka/paymentform', '', 'SSL');



        if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/moka_ccform.tpl')) {
            $this->response->setOutput($this->load->view($this->config->get('config_template') . '/moka_ccform.tpl', $data));
        } else {
            $this->response->setOutput($this->load->view('payment/moka_ccform.tpl', $data));
        }
    }

    /*
     * Post CC data to Moka gateWay
     */

    function post2Moka()
    {
        $this->load->model('checkout/order');
        require_once(DIR_APPLICATION . 'controller/payment/mokaconfig.php');
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $prices = MokaConfig::calculatePrices($order_info['total'], $this->config->get('moka_rates'));

        $record = array(
            'result_code' => '0',
            'result_message' => '',
            'result' => false
        );

        $ins = (int) $this->request->post['cc_installment'];
        // $customer = new Customer($cart->id_customer);
        // $order_sum = $cart->getSummaryDetails();

        $amount = (float) $prices[key($prices)]['installments'][$ins]['total'];
        $installment = $ins;
        $orderid = 'ETIC' . $this->session->data['order_id'];
        $moka_username = $this->config->get('moka_username');
        $moka_password = $this->config->get('moka_password');
        $moka_dealercode = $this->config->get('moka_dealercode');
        $moka_3d_mode = $this->config->get('moka_3d_mode');


        $expire_date = explode('/', $this->request->post['cc_expiry']);

        $moka = array();

        $moka['PaymentDealerAuthentication'] = array(
            'DealerCode' => $moka_dealercode,
            'Username' => $moka_username,
            'Password' => $moka_password,
            'CheckKey' => hash('sha256', $moka_dealercode . 'MK' . $moka_username . 'PD' . $moka_password)
        );

        $moka['PaymentDealerRequest'] = array(
            'CardHolderFullName' => $this->request->post['cc_name'],
            'CardNumber' => str_replace(' ', '', $this->request->post['cc_number']),
            'ExpMonth' => str_replace(' ', '', $expire_date[0]),
            'ExpYear' => "20" . substr(str_replace(' ', '', $expire_date[1]), -2),
            'CvcNumber' => $this->request->post['cc_cvc'],
            'Amount' => $amount,
            'Currency' => $order_info['currency_code'] == 'TRY' ? 'TL' : $order_info['currency_code'],
            'InstallmentNumber' => (string) $ins,
            'OtherTrxCode' => (string) $orderid,
            'ClientIP' => $order_info['ip'],
            'Software' => 'Opencart',
            'RedirectUrl' => $this->url->link('payment/moka/paymentform', 'tdvalidate=1', 'SSL'),
            "IntegratorId" => 1
        );

        $gateway_url = $moka_3d_mode == 'off' ? _MOKA_API_URL_ : _MOKA_3D_URL_;
        $result = json_decode($this->curlPostExt(json_encode($moka), $gateway_url, true));

        if (!$result OR $result == NULL) {
            $record['result_code'] = 'CURL-LOAD_ERROR';
            $record['result_message'] = 'WebServis Error ';
            return $record;
        }

        if (isset($result->ResultCode) AND $result->ResultCode == "Success") {
            if ($moka_3d_mode != 'off')
                header("Location:" . $result->Data);
            if (isset($result->Data->IsSuccessful) AND $result->Data->IsSuccessful) {
                $record['result_code'] = '99';
                $record['result_message'] = $result->ResultCode;
                $record['result'] = true;
                return $record;
            }
            $record['result_code'] = isset($result->Data->ResultCode) ? $result->Data->ResultCode : 'UKN-01';
            $record['result_message'] = isset($result->Data->ResultMessage) ? $result->Data->ResultMessage : 'Hata açıklaması bulunamadı';
            return $record;
        }
        $record['result_code'] = $result->ResultCode;
        $record['result_message'] = ($result->ResultMessage != '' ? $result->ResultMessage : ' Payment Failed').' ('.$result->ResultCode.')';
        return $record;
    }

    function Moka3DValidate()
    {
        $this->load->model('checkout/order');
        $this->load->model('setting/setting');
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $public_key = $this->config->get('moka_username');
        $private_key = $this->config->get('moka_password');

        //begin HASH verification
        $response = $this->request->post;

        $record = $this->getRecordByMokaId($response['orderId']);

        if (!$record)
            die('Order id not found');

        $record['result_code'] = $this->request->post['errorCode'];
        $record['result_message'] = $this->request->post['errorMessage'];
        $record['id_moka'] = $this->request->post['orderId'];
        $record['result'] = false;

        $hash_text = $response['orderId']
                . $response['result']
                . $response['amount']
                . $response['mode']
                . $response['errorCode']
                . $response['errorMessage']
                . $response['transactionDate']
                . $response['publicKey']
                . $private_key;
        $hash = base64_encode(sha1($hash_text, true));

        if ($hash != $response['hash']) { // has yanlışsa
            $record['result_message'] = "Hash uyumlu değil";
            return $record;
        } else { // hash doğru
            if ($response['result'] == 1) { // 3D doğrulama başarılı çekim yap
                $moka_products = array();  // aşağıda düzenlenecek;
                $moka_address = array();  //aşağıda düzenlenecek
                $moka_purchaser = array();  // aşağıda düzenlenecek
                // Müşteri
                $moka_purchaser['name'] = $order_info['firstname'];
                $moka_purchaser['surname'] = $order_info['lastname'];
                $moka_purchaser['email'] = $order_info['email'];
                $moka_purchaser['birthdate'] = NULL;
                $moka_purchaser['gsm_number'] = NULL;
                $moka_purchaser['tc_certificate_number'] = NULL;

                // ADRES
                $moka_address['name'] = $order_info['firstname'];
                $moka_address['surname'] = $order_info['lastname'];
                $moka_address['address'] = $order_info['shipping_address_1'] . ' ' . $order_info['shipping_address_2'];
                $moka_address['zipcode'] = $order_info['shipping_postcode'];
                $moka_address['city_code'] = 34;
                $moka_address['city_text'] = $order_info['shipping_city'];
                $moka_address['country_code'] = "TR";
                $moka_address['country_text'] = "Türkiye";
                $moka_address['phone_number'] = $order_info['telephone'];
                $moka_address['tax_number'] = NULL;
                $moka_address['tax_office'] = NULL;
                $moka_address['tc_certificate_number'] = NULL;
                $moka_address['company_name'] = $order_info['payment_company'];

                // ÜRÜNLER
                $extra_id = 0;
                foreach ($this->cart->getProducts() as $item) {
                    if ($item['total'] == 0)
                        continue;
                    $moka_products[$extra_id]['title'] = $item['name'];
                    $moka_products[$extra_id]['code'] = $item['product_id'] . $extra_id;
                    $moka_products[$extra_id]['quantity'] = $item['quantity'];
                    $moka_products[$extra_id]['price'] = $item['price'];
                    $extra_id++;
                }

                $obj = new MokaPayment();
                $obj->public_key = $public_key;
                $obj->private_key = $private_key;
                $obj->mode = "P";
                $obj->three_d_secure_code = $response['threeDSecureCode'];
                $obj->order_id = $response['orderId'];
                $obj->amount = $response['amount'] / 100;
                $obj->echo = "EticSoft";
                $obj->vendor_id = 4;
                $obj->products = $moka_products;
                $obj->shipping_address = $moka_address;
                $obj->invoice_address = $moka_address;
                $obj->purchaser = $moka_purchaser;

                try {
                    $response = $obj->pay();
                    $record['result_message'] = (string) $response['error_message'];
                    $record['result_code'] = (string) $response['error_code'];
                    $record['amount_paid'] = (float) $response['amount'] / 100;
                    $record['result'] = (int) $response['result'];
                    return $record;
                } catch (Exception $e) {
                    // çekim başarısız doğrulama başarılı
                    $record['result_message'].= "Post error after 3DS";
                    $record['result_code'] = "8888";
                    return $record;
                }
            } else {
                // 3D basarisiz
                $record['result_message'] .= ' -3DS doğrulama yapılamadı ';
                return $record;
            }
        }
    }

    private function curlPostExt($data, $url, $json = false)
    {
        $ch = curl_init(); // initialize curl handle
        curl_setopt($ch, CURLOPT_URL, $url); // set url to post to
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // return into a variable
        if ($json)
            curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-type: application/json"));
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30); // times out after 4s
        curl_setopt($ch, CURLOPT_POST, 1); // set POST method
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data); // add POST fields
        if ($result = curl_exec($ch)) { // run the whole process
            curl_close($ch);
            return $result;
        }
    }

    function getRecordById($id_order)
    {

        $moka_order_id = $id_order;

        $url = 'https://service.moka.com/PaymentDealer/GetDealerPaymentTrxDetailList';
        $moka_username = $this->config->get('moka_username');
        $moka_password = $this->config->get('moka_password');
        $moka_dealercode = $this->config->get('moka_dealercode');

        $moka['PaymentDealerAuthentication'] = array(
            'DealerCode' => $moka_dealercode,
            'Username' => $moka_username,
            'Password' => $moka_password,
            'CheckKey' => hash('sha256', $moka_dealercode . 'MK' . $moka_username . 'PD' . $moka_password)
        );
        $moka['PaymentDealerRequest'] = array(
            'DealerPaymentId' => null,
            'OtherTrxCode' => $moka_order_id
        );
        return json_decode($this->curlPostExt(json_encode($moka), $url, true));
    }

    private function record2Table($record)
    {
        if (!is_array($record))
            return;
        $r = 'Moka işlem No:' . $record->Data->PaymentDetail->DealerPaymentId . " ";
        $r .= 'Sepet toplamı:' . $record->Data->PaymentDetail->DealerCommissionAmount + $record->Data->PaymentDetail->Amount . " ";
        $r .= 'Ödenen:' . $record->Data->PaymentDetail->Amount . " ";
        $r .= 'Komisyon:' . $record->Data->PaymentDetail->DealerCommissionAmount . " ";
        $r .= 'Taksit:' . $$record->Data->PaymentDetail->InstallmentNumber . " ";
        $r .= 'Kart:' . $record->Data->PaymentDetail->CardNumberFirstSix . 'XXX' . $record->Data->PaymentDetail->CardNumberLastFour . ' - ' . $record->Data->PaymentDetail->CardHolderFullName . " ";
        return $r . 'Cevap:' . $record->Data->ResultCode . " ";
    }

}
